'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var _bind = Function.prototype.bind;
exports['default'] = Inject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

'use strong';

function Inject() {
  for (var _len = arguments.length, dependencies = Array(_len), _key = 0; _key < _len; _key++) {
    dependencies[_key] = arguments[_key];
  }

  return function (target) {
    var depends = Array.from(dependencies).map(function (v) {
      if (_lodash2['default'].isFunction(v) && v.name.match(/^([A-Z]|bound [A-Z]|bound constructor)/)) {
        return new v();
      } else {
        return v;
      }
    });
    var stringDepends = dependencies.filter(function (v) {
      return _lodash2['default'].isString(v);
    });

    var constructor = function constructor() {
      var args = Array.from(arguments);
      if (args.length > dependencies.length) {
        args = args.slice(dependencies.length);
        if (args.length === stringDepends.length) {
          args = Array.from(arguments).slice(0, dependencies.length).map(function (v) {
            if (args.length > 0 && _lodash2['default'].isString(v)) {
              return args.shift();
            } else {
              return v;
            }
          });
        }
      }
      return new (_bind.apply(target, [null].concat(_toConsumableArray(args))))();
    };
    constructor.prototype = target.prototype;

    var c = constructor.bind.apply(constructor, [undefined].concat(_toConsumableArray(depends)));
    c.$inject = stringDepends;

    return c;
  };
}

module.exports = exports['default'];